diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user.c gdm-2.28.2/gui/simple-greeter/gdm-user.c
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user.c	2010-01-22 11:17:50.731384714 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user.c	2010-01-24 01:19:38.803538369 -0500
@@ -729,21 +317,8 @@
         g_return_val_if_fail (GDM_IS_USER (user1), 0);
         g_return_val_if_fail (GDM_IS_USER (user2), 0);
 
-        if (user1->real_name != NULL) {
-                str1 = user1->real_name;
-        } else {
-                str1 = user1->user_name;
-        }
-
-        if (user2->real_name != NULL) {
-                str2 = user2->real_name;
-        } else {
-                str2 = user2->user_name;
-        }
-
-        num1 = user1->login_frequency;
-        num2 = user2->login_frequency;
-        g_debug ("Login freq 1=%u 2=%u", (guint)num1, (guint)num2);
+        num1 = user1->props->login_frequency;
+        num2 = user2->props->login_frequency;
         if (num1 > num2) {
                 return -1;
         }
@@ -753,6 +328,18 @@
         }
 
         /* if login frequency is equal try names */
+        if (user1->props->real_name != NULL) {
+                str1 = user1->props->real_name;
+        } else {
+                str1 = user1->props->user_name;
+        }
+
+        if (user2->props->real_name != NULL) {
+                str2 = user2->props->real_name;
+        } else {
+                str2 = user2->props->user_name;
+        }
+
         if (str1 == NULL && str2 != NULL) {
                 return -1;
         }
@@ -799,66 +386,6 @@
         return TRUE;
 }
 
-static char *
-get_filesystem_type (const char *path)
-{
-        GFile      *file;
-        GFileInfo  *file_info;
-        GError     *error;
-        char       *filesystem_type;
-
-        file = g_file_new_for_path (path);
-        error = NULL;
-        file_info = g_file_query_filesystem_info (file,
-                                                  G_FILE_ATTRIBUTE_FILESYSTEM_TYPE,
-                                                  NULL,
-                                                  &error);
-        if (file_info == NULL) {
-                g_warning ("Unable to query filesystem type for %s: %s", path, error->message);
-                g_error_free (error);
-                g_object_unref (file);
-                return NULL;
-        }
-
-        filesystem_type = g_strdup (g_file_info_get_attribute_string (file_info,
-                                                                      G_FILE_ATTRIBUTE_FILESYSTEM_TYPE));
-        if (filesystem_type == NULL) {
-                g_warning ("GIO returned NULL filesystem type for %s", path);
-        }
-
-        g_object_unref (file);
-        g_object_unref (file_info);
-
-        return filesystem_type;
-}
-
-static GdkPixbuf *
-render_icon_from_cache (GdmUser *user,
-                        int      icon_size)
-{
-        GdkPixbuf  *retval;
-        char       *path;
-        gboolean    is_autofs;
-        gboolean    res;
-        char       *filesystem_type;
-
-        path = g_build_filename (GDM_CACHE_DIR, user->user_name, "face", NULL);
-        res = check_user_file (path,
-                               MAX_FILE_SIZE);
-        if (res) {
-                retval = gdk_pixbuf_new_from_file_at_size (path,
-                                                           icon_size,
-                                                           icon_size,
-                                                           NULL);
-        } else {
-                g_debug ("Could not access face icon %s", path);
-                retval = NULL;
-        }
-        g_free (path);
-
-        return retval;
-}
-
 static void
 curved_rectangle (cairo_t *cr,
                   double   x0,
@@ -1092,62 +619,51 @@
 
 GdkPixbuf *
 gdm_user_render_icon (GdmUser   *user,
-                      gint       icon_size)
+                     gboolean  with_frame,
+                     gint      icon_size)
 {
         GdkPixbuf    *pixbuf;
         GdkPixbuf    *framed;
-        char         *path;
-        char         *tmp;
         gboolean      res;
+        GError       *error;
 
         g_return_val_if_fail (GDM_IS_USER (user), NULL);
         g_return_val_if_fail (icon_size > 12, NULL);
 
-        path = NULL;
+        pixbuf = NULL;
+        if (user->props->icon_file) {
+                res = check_user_file (user->props->icon_file,
+                                       MAX_FILE_SIZE);
+                if (res) {
+                        pixbuf = gdk_pixbuf_new_from_file_at_size (user->props->icon_file,
+                                                                   icon_size,
+                                                                   icon_size,
+                                                                   NULL);
+                }
+                else {
+                        pixbuf = NULL;
+                }
+        }
 
-        pixbuf = render_icon_from_cache (user, icon_size);
         if (pixbuf != NULL) {
                 goto out;
         }
 
-        /* Try ${GlobalFaceDir}/${username} */
-        path = g_build_filename (GLOBAL_FACEDIR, user->user_name, NULL);
-        res = check_user_file (path,
-                               MAX_FILE_SIZE);
-        if (res) {
-                pixbuf = gdk_pixbuf_new_from_file_at_size (path,
-                                                           icon_size,
-                                                           icon_size,
-                                                           NULL);
-        } else {
-                g_debug ("Could not access global face icon %s", path);
-                pixbuf = NULL;
-        }
+        error = NULL;
+        pixbuf = gtk_icon_theme_load_icon (gtk_icon_theme_get_default (),
 
-        g_free (path);
-        if (pixbuf != NULL) {
-                goto out;
+                                           "stock_person",
+                                           icon_size,
+                                           GTK_ICON_LOOKUP_FORCE_SIZE,
+                                           &error);
+        if (error) {
+                g_warning ("%s", error->message);
+                g_error_free (error);
         }
 
-        /* Finally, ${GlobalFaceDir}/${username}.png */
-        tmp = g_strconcat (user->user_name, ".png", NULL);
-        path = g_build_filename (GLOBAL_FACEDIR, tmp, NULL);
-        g_free (tmp);
-        res = check_user_file (path,
-                               MAX_FILE_SIZE);
-        if (res) {
-                pixbuf = gdk_pixbuf_new_from_file_at_size (path,
-                                                           icon_size,
-                                                           icon_size,
-                                                           NULL);
-        } else {
-                g_debug ("Could not access global face icon %s", path);
-                pixbuf = NULL;
-        }
-        g_free (path);
  out:
 
-        if (pixbuf != NULL) {
+        if (pixbuf != NULL && with_frame) {
                 framed = frame_pixbuf (pixbuf);
                 if (framed != NULL) {
                         g_object_unref (pixbuf);
@@ -1157,3 +673,232 @@
 
         return pixbuf;
 }
+
+const gchar *
+gdm_user_get_email (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+
+        return user->props->email;
+}
+
+const gchar *
+gdm_user_get_language (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+
+        if (*user->props->language == '\0')
+                return NULL;
+        return user->props->language;
+}
+
+const gchar *
+gdm_user_get_location (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+
+        return user->props->location;
+}
+
+gint
+gdm_user_get_password_mode (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), 0);
+
+        return user->props->password_mode;
+}
+
+const char *
+gdm_user_get_password_hint (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+
+        return user->props->password_hint;
+}
+
+const char *
+gdm_user_get_icon_file (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+
+        return user->props->icon_file;
+}
+
+gboolean
+gdm_user_get_automatic_login (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), FALSE);
+
+        return user->props->automatic_login;
+}
+
+const gchar *
+gdm_user_get_object_path (GdmUser *user)
+{
+        g_return_val_if_fail (GDM_IS_USER (user), NULL);
+
+        return user->object_path;
+}
+
+static gboolean
+update_info (GdmUser *user)
+{
+        UserProperties *props;
+
+        props = user_properties_get (user->bus, user->object_path);
+        if (props != NULL) {
+                if (user->props != NULL)
+                        user_properties_free (user->props);
+                user->props = props;
+                return TRUE;
+        }
+        else {
+                return FALSE;
+        }
+}
+
+static void
+changed_handler (DBusGProxy *proxy,
+                 gpointer   *data)
+{
+        GdmUser *user = GDM_USER (data);
+
+        if (update_info (user)) {
+                g_signal_emit (user, signals[CHANGED], 0);
+        }
+}
+
+GdmUser *
+gdm_user_new_from_object_path (const gchar *object_path)
+{
+        GdmUser *user;
+        GError *error;
+
+        user = (GdmUser *)g_object_new (GDM_TYPE_USER, NULL);
+        user->object_path = g_strdup (object_path);
+
+        error = NULL;
+        user->bus = dbus_g_bus_get (DBUS_BUS_SYSTEM, &error);
+        if (user->bus == NULL) {
+                g_warning ("Couldn't connect to system bus: %s", error->message);
+                goto error;
+        }
+
+        user->proxy = dbus_g_proxy_new_for_name (user->bus,
+                                                 "org.freedesktop.Accounts",
+                                                 user->object_path,
+                                                 "org.freedesktop.Accounts.User");
+        dbus_g_proxy_set_default_timeout (user->proxy, INT_MAX);
+        dbus_g_proxy_add_signal (user->proxy, "Changed", G_TYPE_INVALID);
+
+        dbus_g_proxy_connect_signal (user->proxy, "Changed",
+                                     G_CALLBACK (changed_handler), user, NULL);
+
+        if (!update_info (user))
+                goto error;
+
+        return user;
+
+ error:
+        g_object_unref (user);
+        return NULL;
+}
+
+gboolean
+gdm_user_is_logged_in (GdmUser *user)
+{
+        return user->sessions != NULL;
+}
+
+static int
+session_compare (const char *a,
+                 const char *b)
+{
+        if (a == NULL) {
+                return 1;
+        } else if (b == NULL) {
+                return -1;
+        }
+
+        return strcmp (a, b);
+}
+
+void
+_gdm_user_add_session (GdmUser    *user,
+                       const char *ssid)
+{
+        GList *li;
+
+        g_return_if_fail (GDM_IS_USER (user));
+        g_return_if_fail (ssid != NULL);
+
+        li = g_list_find_custom (user->sessions, ssid, (GCompareFunc)session_compare);
+        if (li == NULL) {
+                g_debug ("GdmUser: adding session %s", ssid);
+                user->sessions = g_list_prepend (user->sessions, g_strdup (ssid));
+                g_signal_emit (user, signals[SESSIONS_CHANGED], 0);
+        } else {
+                g_debug ("GdmUser: session already present: %s", ssid);
+        }
+}
+
+void
+_gdm_user_remove_session (GdmUser    *user,
+                          const char *ssid)
+{
+        GList *li;
+
+        g_return_if_fail (GDM_IS_USER (user));
+        g_return_if_fail (ssid != NULL);
+
+        li = g_list_find_custom (user->sessions, ssid, (GCompareFunc)session_compare);
+        if (li != NULL) {
+                g_debug ("GdmUser: removing session %s", ssid);
+                g_free (li->data);
+                user->sessions = g_list_delete_link (user->sessions, li);
+                g_signal_emit (user, signals[SESSIONS_CHANGED], 0);
+        } else {
+                g_debug ("GdmUser: session not found: %s", ssid);
+        }
+}
+
+guint
+gdm_user_get_num_sessions (GdmUser    *user)
+{
+        return g_list_length (user->sessions);
+}
+
+void
+_gdm_user_show_full_display_name (GdmUser *user)
+{
+        char *uniq_name;
+
+        g_return_if_fail (GDM_IS_USER (user));
+
+        if (user->props->real_name != NULL) {
+                uniq_name = g_strdup_printf ("%s (%s)",
+                                             user->props->real_name,
+                                             user->props->user_name);
+        } else {
+                uniq_name = NULL;
+        }
+
+        if (uniq_name && g_strcmp0 (uniq_name, user->display_name) != 0) {
+                g_free (user->display_name);
+                user->display_name = uniq_name;
+        }
+        else {
+                g_free (uniq_name);
+        }
+}
+
+void
+_gdm_user_show_short_display_name (GdmUser *user)
+{
+        g_return_if_fail (GDM_IS_USER (user));
+
+        if (user->display_name) {
+                g_free (user->display_name);
+                user->display_name = NULL;
+        }
+}
diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-chooser-widget.c gdm-2.28.2/gui/simple-greeter/gdm-user-chooser-widget.c
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user-chooser-widget.c	2010-01-22 11:17:50.380384095 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user-chooser-widget.c	2010-01-23 21:24:57.782789151 -0500
@@ -130,8 +130,6 @@
 static void
 update_other_user_visibility (GdmUserChooserWidget *widget)
 {
-        int number_of_users;
-
         if (!widget->priv->show_user_other) {
                 if (widget->priv->has_user_other) {
                         remove_user_other (widget);
@@ -392,7 +390,7 @@
         }
 
         size = get_icon_height_for_widget (GTK_WIDGET (widget));
-        pixbuf = gdm_user_render_icon (user, size);
+        pixbuf = gdm_user_render_icon (user, TRUE, size);
         if (pixbuf == NULL && widget->priv->stock_person_pixbuf != NULL) {
                 pixbuf = g_object_ref (widget->priv->stock_person_pixbuf);
         }
@@ -400,7 +398,7 @@
         tooltip = g_strdup_printf (_("Log in as %s"),
                                    gdm_user_get_user_name (user));
 
-        is_logged_in = gdm_user_get_num_sessions (user) > 0;
+        is_logged_in = gdm_user_is_logged_in (user);
 
         g_debug ("GdmUserChooserWidget: User added name:%s logged-in:%d pixbuf:%p",
                  gdm_user_get_user_name (user),
@@ -458,6 +456,55 @@
 }
 
 static void
+on_user_changed (GdmUserManager       *manager,
+                 GdmUser              *user,
+                 GdmUserChooserWidget *widget)
+{
+        GdkPixbuf    *pixbuf;
+        char         *tooltip;
+        gboolean      is_logged_in;
+        int           size;
+
+        /* wait for all users to be loaded */
+        if (! widget->priv->loaded) {
+                return;
+        }
+        if (!widget->priv->show_normal_users) {
+                return;
+        }
+
+        size = get_icon_height_for_widget (GTK_WIDGET (widget));
+        pixbuf = gdm_user_render_icon (user, TRUE, size);
+        if (pixbuf == NULL && widget->priv->stock_person_pixbuf != NULL) {
+                pixbuf = g_object_ref (widget->priv->stock_person_pixbuf);
+        }
+
+        tooltip = g_strdup_printf (_("Log in as %s"),
+                                   gdm_user_get_user_name (user));
+
+        is_logged_in = gdm_user_is_logged_in (user);
+
+        g_debug ("GdmUserChooserWidget: User added name:%s logged-in:%d pixbuf:%p",
+                 gdm_user_get_user_name (user),
+                 is_logged_in,
+                 pixbuf);
+
+        gdm_chooser_widget_update_item (GDM_CHOOSER_WIDGET (widget),
+                                        gdm_user_get_user_name (user),
+                                        pixbuf,
+                                        gdm_user_get_display_name (user),
+                                        tooltip,
+                                        gdm_user_get_login_frequency (user),
+                                        is_logged_in,
+                                        FALSE);
+        g_free (tooltip);
+
+        if (pixbuf != NULL) {
+                g_object_unref (pixbuf);
+        }
+}
+
+static void
 on_user_is_logged_in_changed (GdmUserManager       *manager,
                               GdmUser              *user,
                               GdmUserChooserWidget *widget)
@@ -468,7 +515,7 @@
         g_debug ("GdmUserChooserWidget: User logged in changed: %s", gdm_user_get_user_name (user));
 
         user_name = gdm_user_get_user_name (user);
-        is_logged_in = gdm_user_get_num_sessions (user) > 0;
+        is_logged_in = gdm_user_is_logged_in (user);
 
         gdm_chooser_widget_set_item_in_use (GDM_CHOOSER_WIDGET (widget),
                                             user_name,
@@ -533,6 +580,10 @@
                                   G_CALLBACK (on_user_removed),
                                   widget);
                 g_signal_connect (widget->priv->manager,
+                                  "user-changed",
+                                  G_CALLBACK (on_user_changed),
+                                  widget);
+                g_signal_connect (widget->priv->manager,
                                   "users-loaded",
                                   G_CALLBACK (on_users_loaded),
                                   widget);
diff -u -r gdm-2.28.2.pristine/gui/simple-greeter/gdm-user.h gdm-2.28.2/gui/simple-greeter/gdm-user.h
--- gdm-2.28.2.pristine/gui/simple-greeter/gdm-user.h	2010-01-22 11:17:50.819429703 -0500
+++ gdm-2.28.2/gui/simple-greeter/gdm-user.h	2010-01-24 00:16:21.332539155 -0500
@@ -23,7 +23,7 @@
  */
 
 #ifndef __GDM_USER__
-#define __GDM_USER__ 1
+#define __GDM_USER__
 
 #include <sys/types.h>
 #include <gtk/gtk.h>
@@ -37,23 +37,36 @@
 
 typedef struct _GdmUser GdmUser;
 
-GType                 gdm_user_get_type            (void) G_GNUC_CONST;
+GType          gdm_user_get_type            (void) G_GNUC_CONST;
 
-uid_t                 gdm_user_get_uid             (GdmUser   *user);
-G_CONST_RETURN char  *gdm_user_get_user_name       (GdmUser   *user);
-G_CONST_RETURN char  *gdm_user_get_real_name       (GdmUser   *user);
-G_CONST_RETURN char  *gdm_user_get_display_name    (GdmUser   *user);
-G_CONST_RETURN char  *gdm_user_get_home_directory  (GdmUser   *user);
-G_CONST_RETURN char  *gdm_user_get_shell           (GdmUser   *user);
-guint                 gdm_user_get_num_sessions    (GdmUser   *user);
-GList                *gdm_user_get_sessions        (GdmUser   *user);
-gulong                gdm_user_get_login_frequency (GdmUser   *user);
+GdmUser        *gdm_user_new_from_object_path (const gchar *path);
+const gchar   *gdm_user_get_object_path      (GdmUser *user);
 
-GdkPixbuf            *gdm_user_render_icon         (GdmUser   *user,
-                                                    gint       icon_size);
-
-gint                  gdm_user_collate             (GdmUser   *user1,
-                                                    GdmUser   *user2);
+uid_t          gdm_user_get_uid             (GdmUser   *user);
+const gchar   *gdm_user_get_user_name       (GdmUser   *user);
+const gchar   *gdm_user_get_display_name    (GdmUser   *user);
+const gchar   *gdm_user_get_real_name       (GdmUser   *user);
+const gchar   *gdm_user_get_display_name    (GdmUser   *user);
+gint           gdm_user_get_account_type    (GdmUser   *user);
+const gchar   *gdm_user_get_email           (GdmUser   *user);
+const gchar   *gdm_user_get_language        (GdmUser   *user);
+const gchar   *gdm_user_get_location        (GdmUser   *user);
+const gchar   *gdm_user_get_home_directory  (GdmUser   *user);
+const gchar   *gdm_user_get_shell           (GdmUser   *user);
+gulong         gdm_user_get_login_frequency (GdmUser   *user);
+gint           gdm_user_get_password_mode   (GdmUser   *user);
+const gchar   *gdm_user_get_password_hint   (GdmUser   *user);
+const gchar   *gdm_user_get_icon_file       (GdmUser   *user);
+gboolean       gdm_user_get_automatic_login (GdmUser   *user);
+
+gboolean       gdm_user_is_logged_in        (GdmUser   *user);
+guint          gdm_user_get_num_sessions    (GdmUser   *user);
+
+GdkPixbuf     *gdm_user_render_icon         (GdmUser   *user,
+                                            gboolean  framed,
+                                            gint      icon_size);
+gint           gdm_user_collate             (GdmUser   *user1,
+                                            GdmUser   *user2);
 
 G_END_DECLS
 
